| IGLib 1.4 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Properties

# IG::Num::IPenaltyEvaluator Interface Reference

Classes that evaluates penalty terms corresponding to a specific penalty function. More...

Inheritance diagram for IG::Num::IPenaltyEvaluator:
[legend]

List of all members.

## Public Member Functions
void | SetPenaltyFunction (int which, IRealFunctionPenalty function)
| Sets the penalty function used for evaluation of the specified penalty term.
void | SetPenaltyFunction (int which, double barrierLength, double barrierHeight)
| Sets the penalty function used for evaluation of the specified penalty term.
void | SetPenaltyFunction (int which, double barrierLength, double barrierHeight, double zeroEnd)
| Sets the penalty function used for evaluation of the specified penalty term.
bool | CanSetBarrierLength (int which)
| Returns a flag that tells whether characteristic barrier length can be set for the penalty function of the specified constraint.
bool | CansetBarrierHeight (int which)
| Returns a flag that tells whether characteristic barrier height can be set for the penalty function of the specified constraint.
bool | CanSetMaxZero (int which)
| Returns a flag that tells whether maxmal argument where function is zero can be set for the penalty function of the specified constraint.
int | AddPenaltyFunction (IRealFunctionPenalty func)
| Adds a new penalty function for evaluation of penalty terms to the list.
IRealFunctionPenalty | GetPenaltyFunction (int which)
| Returns penalty function corresonding to the specified constraint.
bool | IsPenaltyValueDefined (int which)
| Returns true if the penalty function value can be calculated for the specified constraint, or false otherwise.
bool | IsPenaltyDerivativeDefined (int which)
| Returns true if the penalty function derivative can be calculated for the specified constraint, or false otherwise.
bool | IsPenaltySecodDerivativeDefined (int which)
| Returns true if the penalty function's second can be calculated for the specified constraint, or false otherwise.
double | PenaltyValue (int which, double constraintValue)
| Returns value of the penalty function for the specified constraint at the specified value of the corresponding constraint function.
double | PenaltyDerivative (int which, double constraintValue)
| Returns derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.
double | PenaltySecondDerivative (int which, double constraintValue)
| Returns second derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.
## Properties
bool | AllowSingleFunction`[get, set]`
| Whether a single function can be used for evaluating penalty terms corresponding to different constraints.
List< IRealFunctionPenalty > | PenaltyFunctions`[get]`
| Returns a list of penalty functions used to evaluate penalty terms.

## Detailed Description

Classes that evaluates penalty terms corresponding to a specific penalty function.

## Member Function Documentation

void IG::Num::IPenaltyEvaluator::SetPenaltyFunction | ( | int | which,
|  | IRealFunctionPenalty | function
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters:

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  function | Function to be used for evaluation of the specified penalty term.

Implemented in IG::Num::PenaltyEvaluator.

void IG::Num::IPenaltyEvaluator::SetPenaltyFunction | ( | int | which,
|  | double | barrierLength,
|  | double | barrierHeight
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters:

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  barrierLength | Characteristic barrier length of the created function. This is the length at which function grows from approximately 0 to characteristic height.
  barrierHeight | Characteristic barrier height of the created function.

Implemented in IG::Num::PenaltyEvaluator.

void IG::Num::IPenaltyEvaluator::SetPenaltyFunction | ( | int | which,
|  | double | barrierLength,
|  | double | barrierHeight,
|  | double | zeroEnd
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters:

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  barrierLength | Characteristic barrier length of the created function. This is the length at which function grows from approximately 0 to characteristic height.
  barrierHeight | Characteristic barrier height of the created function.
  zeroEnd | Maximal argumet for which penalty function is still 0.

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::CanSetBarrierLength | ( | int | which | ) |

Returns a flag that tells whether characteristic barrier length can be set for the penalty function of the specified constraint.

Parameters:

  which | Specified the constraiint in question.

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::CansetBarrierHeight | ( | int | which | ) |

Returns a flag that tells whether characteristic barrier height can be set for the penalty function of the specified constraint.

Parameters:

  which | Specified the constraiint in question.

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::CanSetMaxZero | ( | int | which | ) |

Returns a flag that tells whether maxmal argument where function is zero can be set for the penalty function of the specified constraint.

Parameters:

  which | Specified the constraiint in question.

Implemented in IG::Num::PenaltyEvaluator.

int IG::Num::IPenaltyEvaluator::AddPenaltyFunction | ( | IRealFunctionPenalty | func | ) |

Adds a new penalty function for evaluation of penalty terms to the list.

Parameters:

  func | Function to be added.

Returns:
  Index of the added penalty function (0 if this is the first function on the list).

Implemented in IG::Num::PenaltyEvaluator.

IRealFunctionPenalty IG::Num::IPenaltyEvaluator::GetPenaltyFunction | ( | int | which | ) |

Returns penalty function corresonding to the specified constraint.

Parameters:

  which | Index of penalty function (or the corresponding constraint).

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::IsPenaltyValueDefined | ( | int | which | ) |

Returns true if the penalty function value can be calculated for the specified constraint, or false otherwise.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::IsPenaltyDerivativeDefined | ( | int | which | ) |

Returns true if the penalty function derivative can be calculated for the specified constraint, or false otherwise.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

bool IG::Num::IPenaltyEvaluator::IsPenaltySecodDerivativeDefined | ( | int | which | ) |

Returns true if the penalty function's second can be calculated for the specified constraint, or false otherwise.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

double IG::Num::IPenaltyEvaluator::PenaltyValue | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns value of the penalty function for the specified constraint at the specified value of the corresponding constraint function.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

double IG::Num::IPenaltyEvaluator::PenaltyDerivative | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

double IG::Num::IPenaltyEvaluator::PenaltySecondDerivative | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns second derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.

Parameters:

  which | Specifies the constraint in question.

Implemented in IG::Num::PenaltyEvaluator.

## Property Documentation

bool IG::Num::IPenaltyEvaluator::AllowSingleFunction`[get, set]`

Whether a single function can be used for evaluating penalty terms corresponding to different constraints.

Implemented in IG::Num::PenaltyEvaluator.

List<IRealFunctionPenalty> IG::Num::IPenaltyEvaluator::PenaltyFunctions`[get]`

Returns a list of penalty functions used to evaluate penalty terms.

Implemented in IG::Num::PenaltyEvaluator.

The documentation for this interface was generated from the following file:

- AnalysisResutlsInt.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events